using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Runtime.Serialization;
using Syncfusion.Windows.Forms.Tools;

namespace Docking
{
    public partial class Form1 : Form
    {

        bool flag = true;
        static int count = 0;
        Panel panel;
        private TabbedMDIManager tmm;
        public Form1()
        {
                     
            InitializeComponent();
            tmm = new TabbedMDIManager();
            this.IsMdiContainer = true;
            tmm.AttachToMdiContainer(this);
            this.FormClosing += new FormClosingEventHandler(Form1_FormClosing);
            this.dockingManager1.NewDockStateEndLoad += new EventHandler(dockingManager1_NewDockStateEndLoad);
            this.SizeChanged += new EventHandler(Form1_SizeChanged);
            
        }
               

        void Form1_SizeChanged(object sender, EventArgs e)
        {
            Console.WriteLine("Form1 size changed event triggered");
            //Checks if the window state is minimized. If it is true,Dock visibility is false. 
            //otherwise visibility set to true. 
            if (this.WindowState == FormWindowState.Minimized)
            {
                this.SaveDockStateInfo();
                this.dockingManager1.SetDockVisibility(this.panel1, false);
            }
            else
            {
                this.dockingManager1.SetDockVisibility(this.panel1, true);
                this.LoadDockStateInfo();
            } 

        }


        void dockingManager1_NewDockStateEndLoad(object sender, EventArgs e)
        {
            if (flag)
            {
                flag = false;
                LoadDockStateInfo();
            }
        }

        void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            SaveDockStateInfo();
        }

        //To save dock states
   public void SaveDockStateInfo()
        {
            ArrayList temp = new ArrayList();
            foreach (Control c in this.dockingManager1.ControlsArray)
                temp.Add(c.Name);
            AppStateSerializer aser = new AppStateSerializer(SerializeMode.XMLFile, "c:\\docksettings");
            aser.SerializeObject("runtimecontrols", temp);
            this.dockingManager1.SaveDockState(aser);
            aser.PersistNow();
          
        }
        //To load dock states
   public void LoadDockStateInfo()
        {
            try
            {
                   
                    AppStateSerializer aser = new AppStateSerializer(SerializeMode.XMLFile, "c:\\docksettings");
                    ArrayList temp = new ArrayList();
                    temp = (ArrayList)aser.DeserializeObject("runtimecontrols");
                    Panel[] p = new Panel[temp.Count];
                    for (int i = 0; i < temp.Count; i++)
                    {
                        p[i] = new Panel();
                        p[i].Name = (string)temp[i];
                        this.Controls.Add(p[i]);
                        this.dockingManager1.SetEnableDocking(p[i], true);
                    }

                    this.dockingManager1.LoadDockState(aser);
                }
            
            catch (Exception ex)
            { }
        }

     
        private void panel1_Paint(object sender, PaintEventArgs e)
        {

        }

        private void panel3_Paint(object sender, PaintEventArgs e)
        {

        }
        //To dynamically create panels
        private void button1_Click(object sender, EventArgs e)
        {
            Random rn = new Random();
            count = rn.Next() % 1000;
             panel = new Panel();
            panel.Name = "panel" + count.ToString();
            this.dockingManager1.SetEnableDocking(panel, true);
            //this.dockingManager1.DockControl(panel, this.panel1, DockingStyle.Tabbed, 100);
            this.dockingManager1.SetAsMDIChild(panel, true);
            
        }
    }
}